<?php
/**
 * Filter handler
 *
 * @copyright       The XOOPS project http://sourceforge.net/projects/xoops/
 * @license         http://www.fsf.org/copyleft/gpl.html GNU public license
 * @author          Taiwen Jiang <phppp@users.sourceforge.net>
 * @since           1.00
 * @version         $Id: functions.filter.php 1901 2008-07-26 04:05:57Z phppp $
 * @package         Frameworks
 * @subpackage      art
 */

if (!defined("FRAMEWORKS_ART_FUNCTIONS_FILTER")):
define("FRAMEWORKS_ART_FUNCTIONS_FILTER", true);

/**
 * load all local filters for an object
 * 
 * Filter distribution:
 * In each module folder there is a folder "filter" containing filter files with, 
 * filename: [name of target class][.][function/action name][.php];
 * function name: [name of target class][_][function/action name];
 * parameter: the target object
 *
 * @param   string     $object    class name or object
 * @param   string     $method    function or action name
 * @access public
 */
function mod_loadFilters(&$object, $method)
{
    xoops_load("cache");
    if (!$modules_active = XoopsCache::read("system_modules_active")) {
        $module_handler =& xoops_gethandler('module');
        $modules_obj = $module_handler->getObjects(new Criteria('isactive', 1));
        $modules_active = array();
        foreach (array_keys($modules_obj) as $key) {
            $modules_active[] = $modules_obj[$key]->getVar("dirname");
        }
        unset($modules_obj);
        XoopsCache::write("system_modules_active", $modules_active);
    }
    $class = is_object($object) ? get_class($object) : $object;
    foreach ($modules_active as $f) {
        if (!@include_once XOOPS_ROOT_PATH."/modules/{$f}/filter/{$class}.{$method}.php") continue;
        if (function_exists("{$class}_{$method}")) call_user_func_array("{$class}_{$method}", array(&$object));
    }
}
    
endif;
    
?>